#include	"simpletext.h"
#include	"sermsg.h"
#include	"sersendf.h"
#include	<stdint.h>

int main(void)
{
    int8_t int8_min = INT8_MIN;
    int8_t int8_max = INT8_MAX;
    int16_t int16_min = INT16_MIN;
    int16_t int16_max = INT16_MAX;
    int32_t int32_min = INT32_MIN;
    int32_t int32_max = INT32_MAX;
    uint8_t uint8_min = 0;
    uint8_t uint8_max = UINT8_MAX;
    uint16_t uint16_min = 0;
    uint16_t uint16_max = UINT16_MAX;
    uint32_t uint32_min = 0;
    uint32_t uint32_max = UINT32_MAX;
    
    putStr("Hello World\n\n");
    putStr("Let's test the sermsg.c functions with various data types,\n");
    putStr("just to see if they are working correctly.  Please note that\n");
    putStr("the minimum and maximum values of these data types were obtained\n");
    putStr("from stdint.h, which is included in SerialTest.c.  With the\n");
    putStr("exception of several zeros, most of the variables representing\n");
    putStr("the minimum and maximum values were initialised with constants\n");
    putStr("taken from stdint.h.\n\n");
    
    putStr("int8_t has a minimum value of ");    
    serwrite_int8(int8_min);
    putStr(" and a maximum value of ");
    serwrite_int8(int8_max);
    putStr(".\n\n");
    
    putStr("uint8_t has a minimum value of ");    
    serwrite_uint8(uint8_min);
    putStr(" and a maximum value of ");
    serwrite_uint8(uint8_max);
    putStr(".\n\n");
    
    putStr("int16_t has a minimum value of ");    
    serwrite_int16(int16_min);
    putStr(" and a maximum value of ");
    serwrite_int16(int16_max);
    putStr(".\n\n");
    
    putStr("uint16_t has a minimum value of ");
    serwrite_uint16(uint16_min);
    putStr(" and a maximum value of ");
    serwrite_uint16(uint16_max);
    putStr(".\n\n");
    
    putStr("int32_t has a minimum value of ");    
    serwrite_int32(int32_min);
    putStr(" and a maximum value of ");
    serwrite_int32(int32_max);
    putStr(".\n\n");
    
    putStr("uint32_t has a minimum value of ");    
    serwrite_uint32(uint32_min);
    putStr(" and a maximum value of ");
    serwrite_uint32(uint32_max);
    putStr(".\n\n");
    
    putStr("Special case hex4 minimum value: ");
    serwrite_hex4(uint8_min);
    putStr("\nSpecial case hex4 maximum value: ");
    serwrite_hex4(uint8_max);
    putStr("\n\n");

    putStr("Minimum value of uint8_t in hexadecimal format: ");    
    serwrite_hex8(uint8_min);
    putStr("\nMaximum value of uint8_t in hexadecimal format: ");
    serwrite_hex8(uint8_max);
    putStr("\n\n");
    
    putStr("Minimum value of uint16_t in hexadecimal format: ");    
    serwrite_hex16(uint16_min);
    putStr("\nMaximum value of uint16_t in hexadecimal format: ");
    serwrite_hex16(uint16_max);
    putStr("\n\n");
    
    putStr("Minimum value of uint32_t in hexadecimal format: ");    
    serwrite_hex32(uint32_min);
    putStr("\nMaximum value of uint32_t in hexadecimal format: ");
    serwrite_hex32(uint32_max);
    putStr("\n\n");
    
    putStr("Let's now move a decimal point around the maximum value of a uint32_t data type.\n\n");
    putStr("Starting value: ");
    serwrite_uint32(uint32_max);
    putStr("\n\n");
    
    uint8_t i;
    
    for(i = 1; i < 10; i++)
    {
        serwrite_uint32_vf(uint32_max, i);
        putStr("\n");
    }
    
    putStr("\n");
    
    putStr("Let's now move a decimal point around the minimum value of a int32_t data type.\n\n");
    putStr("Starting value: ");
    serwrite_int32(int32_min);
    putStr("\n\n");
    
    for(i = 1; i < 10; i++)
    {
        serwrite_int32_vf(int32_min, i);
        putStr("\n");
    }
    
    putStr("\n");
    
    putStr("Everything appears to be working well within sermsg.c, so let's move on to testing\n");
    putStr("the sersendf_P function within sersendf.c.  This function takes a formatted string,\n");
    putStr("containing a wide variety of data types, and outputs it to the terminal.\n\n");
    
    sersendf_P(PSTR("Can we simply output a string to the terminal, with the sersendf_P function?\nYes, this question and answer prove it!\n\n"));    
    
    sersendf_P(PSTR("Minimum value of a int8_t data type: %sd%\n"), int8_min);
    sersendf_P(PSTR("Maximum value of a int8_t data type: %sd%\n\n"), int8_max);
    
    sersendf_P(PSTR("Minimum value of a uint8_t data type: %su%\n"), uint8_min);
    sersendf_P(PSTR("Maximum value of a uint8_t data type: %su%\n\n"), uint8_max);
    
    sersendf_P(PSTR("Minimum value of a int16_t data type: %d%\n"), int16_min);
    sersendf_P(PSTR("Maximum value of a int16_t data type: %d%\n\n"), int16_max);
    
    sersendf_P(PSTR("Minimum value of a uint16_t data type: %u%\n"), uint16_min);
    sersendf_P(PSTR("Maximum value of a uint16_t data type: %u%\n\n"), uint16_max);
    
    sersendf_P(PSTR("Minimum value of a int32_t data type: %ld%\n"), int32_min);
    sersendf_P(PSTR("Maximum value of a int32_t data type: %ld%\n\n"), int32_max);
    
    sersendf_P(PSTR("Minimum value of a uint32_t data type: %lu%\n"), uint32_min);
    sersendf_P(PSTR("Maximum value of a uint32_t data type: %lu%\n\n"), uint32_max);
    
    sersendf_P(PSTR("Minimum value of a uint8_t data type in hexadecimal: %sx%\n"), uint8_min);    
    sersendf_P(PSTR("Maximum value of a uint8_t data type in hexadecimal: %sx%\n\n"), uint8_max);
    
    sersendf_P(PSTR("Minimum value of a uint16_t data type in hexadecimal: %x%\n"), uint16_min);    
    sersendf_P(PSTR("Maximum value of a uint16_t data type in hexadecimal: %x%\n\n"), uint16_max);
    
    sersendf_P(PSTR("Minimum value of a uint32_t data type in hexadecimal: %lx%\n"), uint32_min);    
    sersendf_P(PSTR("Maximum value of a uint32_t data type in hexadecimal: %lx%\n\n"), uint32_max);
    
    sersendf_P(PSTR("Let's now test some characters.\n\n"));
    
    uint8_t uiG = 71;
    uint8_t uiO = 79;
    uint8_t uiD = 68;
    uint8_t uiB = 66;
    uint8_t uiY = 89;
    uint8_t uiE = 69;
    
    sersendf_P(PSTR("%c%c%c%c%c%c%c"), uiG, uiO, uiO, uiD, uiB, uiY, uiE);
    
  return 0;
}